package routers

import (
	beego "github.com/beego/beego/v2/server/web"
	"github.com/beego/beego/v2/server/web/context/param"
)

func init() {

    beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/chat`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiController"],
        beego.ControllerComments{
            Method: "TopicDelete",
            Router: `/topic/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiController"],
        beego.ControllerComments{
            Method: "TopicDetail",
            Router: `/topic/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiController"],
        beego.ControllerComments{
            Method: "TopicEdit",
            Router: `/topic/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiController"],
        beego.ControllerComments{
            Method: "TopicList",
            Router: `/topic/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiFileController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiFileController"],
        beego.ControllerComments{
            Method: "FileRetrieve",
            Router: `/file/retrieve`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiFileController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/ai:AiFileController"],
        beego.ControllerComments{
            Method: "FileUpload",
            Router: `/file/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "AddChartClassify",
            Router: `/chart_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassify",
            Router: `/chart_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassifyCheck",
            Router: `/chart_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "EditChartClassify",
            Router: `/chart_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyItems",
            Router: `/chart_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyList",
            Router: `/chart_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyMove",
            Router: `/chart_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/chart_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Copy",
            Router: `/chart_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/chart_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "DetailFromUniqueCode",
            Router: `/chart_info/detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/chart_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "EnInfoEdit",
            Router: `/chart_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/chart_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/chart_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Newest",
            Router: `/chart_info/newest`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Preview",
            Router: `/chart_info/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Refresh",
            Router: `/chart_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "SearchByEs",
            Router: `/chart_info/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/chart_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "Copy",
            Router: `/chart_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "DeleteChart",
            Router: `/chart_info/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/chart_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/chart_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "EnInfoEdit",
            Router: `/chart_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/chart_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/chart_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "Preview",
            Router: `/chart_info/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "Refresh",
            Router: `/chart_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "Relation",
            Router: `/chart_info/relation`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/chart_info/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ChartInfoController"],
        beego.ControllerComments{
            Method: "SearchByEs",
            Router: `/chart_info/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassify",
            Router: `/classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassifyCheck",
            Router: `/classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ClassifyController"],
        beego.ControllerComments{
            Method: "EditChartClassify",
            Router: `/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ClassifyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:ClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyMove",
            Router: `/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/tag/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/tag/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"],
        beego.ControllerComments{
            Method: "DeleteCheck",
            Router: `/tag/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/tag/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/tag/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"],
        beego.ControllerComments{
            Method: "VarietyEdbList",
            Router: `/tag/variety_edb/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:TagController"],
        beego.ControllerComments{
            Method: "SaveVarietyEdb",
            Router: `/tag/variety_edb/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:VarietyController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/variety/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:VarietyController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/variety/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:VarietyController"],
        beego.ControllerComments{
            Method: "DeleteCheck",
            Router: `/variety/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:VarietyController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/variety/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/cross_variety:VarietyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/variety/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"],
        beego.ControllerComments{
            Method: "AddEdb",
            Router: `/edb/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"],
        beego.ControllerComments{
            Method: "EditEdb",
            Router: `/edb/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"],
        beego.ControllerComments{
            Method: "EdbList",
            Router: `/edb/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"],
        beego.ControllerComments{
            Method: "EdbRefresh",
            Router: `/edb/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"],
        beego.ControllerComments{
            Method: "BaseExcelDetail",
            Router: `/excel/base`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"],
        beego.ControllerComments{
            Method: "ExcelDataList",
            Router: `/excel/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"],
        beego.ControllerComments{
            Method: "ExcelByName",
            Router: `/excel_by_name`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:CustomAnalysisController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "AddExcelClassify",
            Router: `/excel_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "DeleteExcelClassify",
            Router: `/excel_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "DeleteExcelClassifyCheck",
            Router: `/excel_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "EditExcelClassify",
            Router: `/excel_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "ExcelClassifyItems",
            Router: `/excel_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/excel_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "ExcelClassifyMove",
            Router: `/excel_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/excel_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetBaseEdbInfo",
            Router: `/excel_info/base_edb_info`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Copy",
            Router: `/excel_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/excel_info/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/excel_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "AddDraft",
            Router: `/excel_info/draft/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/excel_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetSystemDate",
            Router: `/excel_info/get_system_date`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/excel_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "MarkEditStatus",
            Router: `/excel_info/mark`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "CalculateData",
            Router: `/excel_info/mixed/calculate`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetMixDateCalculate",
            Router: `/excel_info/mixed/date_calculate`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/excel_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "BatchRefresh",
            Router: `/excel_info/table/batch_refresh`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetBatchChartRefreshResult",
            Router: `/excel_info/table/batch_refresh/result`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Calculate",
            Router: `/excel_info/table/calculate`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Download",
            Router: `/excel_info/table/download`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetFirstEdbData",
            Router: `/excel_info/table/first_edb_data_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetFutureDateData",
            Router: `/excel_info/table/future_date_list`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetHistoryDateData",
            Router: `/excel_info/table/history_date_list`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetOtherEdbData",
            Router: `/excel_info/table/other_edb_data_list`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Refresh",
            Router: `/excel_info/table/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/excel:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetExcelTableData",
            Router: `/excel_info/table_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "AddChartClassify",
            Router: `/chart_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassify",
            Router: `/chart_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassifyCheck",
            Router: `/chart_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "EditChartClassify",
            Router: `/chart_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyItems",
            Router: `/chart_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyList",
            Router: `/chart_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyMove",
            Router: `/chart_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoAdd",
            Router: `/chart_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoBase64Upload",
            Router: `/chart_info/base64Upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "BaseChartInfoDetailFromUniqueCode",
            Router: `/chart_info/base_detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "CopyChartInfo",
            Router: `/chart_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoDetail",
            Router: `/chart_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoDetailFromUniqueCode",
            Router: `/chart_info/detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoEdbInfoDetail",
            Router: `/chart_info/edb_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoEdbInfoSearch",
            Router: `/chart_info/edb_info/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoEdit",
            Router: `/chart_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartEnInfoEdit",
            Router: `/chart_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoImageSet",
            Router: `/chart_info/image/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartList",
            Router: `/chart_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoMove",
            Router: `/chart_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoNewest",
            Router: `/chart_info/newest`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "PreviewBarChartInfo",
            Router: `/chart_info/preview_bar`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ProfitChartInfoAdd",
            Router: `/chart_info/profit/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ProfitChartInfoEdit",
            Router: `/chart_info/profit/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "PreviewProfitChartInfo",
            Router: `/chart_info/profit/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoRefresh",
            Router: `/chart_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoSave",
            Router: `/chart_info/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoSearchByEs",
            Router: `/chart_info/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"],
        beego.ControllerComments{
            Method: "FutureGoodEdbInfoDataList",
            Router: `/edb_info/data/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"],
        beego.ControllerComments{
            Method: "FutureGoodEdbInfoGroupList",
            Router: `/edb_info/group/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"],
        beego.ControllerComments{
            Method: "FutureGoodEdbInfoList",
            Router: `/edb_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"],
        beego.ControllerComments{
            Method: "FutureGoodEdbExchangeList",
            Router: `/exchange/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "AddChartClassify",
            Router: `/chart_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassify",
            Router: `/chart_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassifyCheck",
            Router: `/chart_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "EditChartClassify",
            Router: `/chart_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyItems",
            Router: `/chart_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyList",
            Router: `/chart_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyMove",
            Router: `/chart_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "Copy",
            Router: `/chart_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/chart_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "DetailFromUniqueCode",
            Router: `/chart_info/detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "EnInfoEdit",
            Router: `/chart_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/chart_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/chart_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "Preview",
            Router: `/chart_info/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "Refresh",
            Router: `/chart_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/chart_info/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "SearchByEs",
            Router: `/chart_info/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "GetMultipleGraphConfig",
            Router: `/multiple_graph/config/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "AddChartClassify",
            Router: `/chart_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassify",
            Router: `/chart_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassifyCheck",
            Router: `/chart_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "EditChartClassify",
            Router: `/chart_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyItems",
            Router: `/chart_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyList",
            Router: `/chart_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyMove",
            Router: `/chart_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphConfigSaveChart",
            Router: `/chart/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "Copy",
            Router: `/chart_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/chart_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "DetailFromUniqueCode",
            Router: `/chart_info/detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "EnInfoEdit",
            Router: `/chart_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/chart_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/chart_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "Refresh",
            Router: `/chart_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "SearchByEs",
            Router: `/chart_info/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "GetMultipleGraphConfig",
            Router: `/config/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphConfigSave",
            Router: `/config/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphConfigSaveEdb",
            Router: `/edb/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphPreview",
            Router: `/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphPreviewCurve",
            Router: `/preview_cure`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/variety/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "Analysis",
            Router: `/variety/analysis`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EdbDataExport",
            Router: `/variety/data/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/variety/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "DeleteCheck",
            Router: `/variety/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/variety/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "AddToEdb",
            Router: `/variety/edb/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EdbDataList",
            Router: `/variety/edb/data/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EdbDataListV2",
            Router: `/variety/edb/data/list/v2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EdbInfoDataSeasonal",
            Router: `/variety/edb/data/seasonal`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EdbInfoDataTb",
            Router: `/variety/edb/data/tb`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EdbList",
            Router: `/variety/edb/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/variety/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/variety/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "AddPlant",
            Router: `/variety/plant/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "CopyPlant",
            Router: `/variety/plant/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "DeletePlant",
            Router: `/variety/plant/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EditPlant",
            Router: `/variety/plant/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "PlantList",
            Router: `/variety/plant/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "ModifyProductionDay",
            Router: `/variety/production_day/modify`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:BaseFromChangesVisitorsCovidController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:BaseFromChangesVisitorsCovidController"],
        beego.ControllerComments{
            Method: "VisitorsCovidLastDate",
            Router: `/visitors_covid/last_date`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:BaseFromChangesVisitorsCovidController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:BaseFromChangesVisitorsCovidController"],
        beego.ControllerComments{
            Method: "VisitorsCovidList",
            Router: `/visitors_covid/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:BaseFromNationalStatisticsController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:BaseFromNationalStatisticsController"],
        beego.ControllerComments{
            Method: "ClassifyList",
            Router: `/base_from_national_statistics/classify_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:BaseFromNationalStatisticsController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:BaseFromNationalStatisticsController"],
        beego.ControllerComments{
            Method: "DbList",
            Router: `/base_from_national_statistics/db_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:BaseFromNationalStatisticsController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:BaseFromNationalStatisticsController"],
        beego.ControllerComments{
            Method: "IndexDetail",
            Router: `/base_from_national_statistics/index_detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:BaseFromNationalStatisticsController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:BaseFromNationalStatisticsController"],
        beego.ControllerComments{
            Method: "IndexList",
            Router: `/base_from_national_statistics/index_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "AddChartClassify",
            Router: `/chart_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyChartListV2",
            Router: `/chart_classify/chart/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassify",
            Router: `/chart_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassifyCheck",
            Router: `/chart_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "EditChartClassify",
            Router: `/chart_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyItems",
            Router: `/chart_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyListV2",
            Router: `/chart_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyMove",
            Router: `/chart_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "AddManualClassify",
            Router: `/manual/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "ManualClassifyDel",
            Router: `/manual/classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "ManualClassifyEdit",
            Router: `/manual/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"],
        beego.ControllerComments{
            Method: "EditPublic",
            Router: `/edit_public`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"],
        beego.ControllerComments{
            Method: "PublicMenu",
            Router: `/public_menu`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"],
        beego.ControllerComments{
            Method: "Remove",
            Router: `/remove`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartFrameworkController"],
        beego.ControllerComments{
            Method: "Rename",
            Router: `/rename`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoAdd",
            Router: `/chart_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoBase64Upload",
            Router: `/chart_info/base64Upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CommonChartInfoDetailFromUniqueCode",
            Router: `/chart_info/common/detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoConvertDetail",
            Router: `/chart_info/convert/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CopyChartInfo",
            Router: `/chart_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoDetail",
            Router: `/chart_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoDetailFromUniqueCode",
            Router: `/chart_info/detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "PreviewChartInfoDetail",
            Router: `/chart_info/detail/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoDetailV2",
            Router: `/chart_info/detail/v2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoEdbInfoDetail",
            Router: `/chart_info/edb_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoEdbInfoSearch",
            Router: `/chart_info/edb_info/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoEdit",
            Router: `/chart_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartEnInfoEdit",
            Router: `/chart_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoImageSet",
            Router: `/chart_info/image/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoMove",
            Router: `/chart_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoNewest",
            Router: `/chart_info/newest`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "PreviewRadarChartInfo",
            Router: `/chart_info/preview/radar`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "PreviewSectionScatterChartInfo",
            Router: `/chart_info/preview/time_section`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "PreviewBarChartInfo",
            Router: `/chart_info/preview_bar`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoSave",
            Router: `/chart_info/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoSearch",
            Router: `/chart_info/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoSearchByEs",
            Router: `/chart_info/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "SaveAdjustEdbInfo",
            Router: `/edb_info/adjust/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateBatchEdit",
            Router: `/edb_info/calculate/batch/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "BatchCalculateBatchEdit",
            Router: `/edb_info/calculate/batch/edit/batch`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateBatchReset",
            Router: `/edb_info/calculate/batch/reset`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateBatchSave",
            Router: `/edb_info/calculate/batch/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "BatchCalculateBatchSave",
            Router: `/edb_info/calculate/batch/save/batch`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateComputeCorrelation",
            Router: `/edb_info/calculate/compute_correlation`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateDetail",
            Router: `/edb_info/calculate/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateEdit",
            Router: `/edb_info/calculate/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateMapping",
            Router: `/edb_info/calculate/mapping`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateMultiChoice",
            Router: `/edb_info/calculate/multi/choice`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateMultiSearch",
            Router: `/edb_info/calculate/multi/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateSave",
            Router: `/edb_info/calculate/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoData",
            Router: `/edb_info/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoDataSeasonal",
            Router: `/edb_info/data/seasonal`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoDataTb",
            Router: `/edb_info/data/tb`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "AddPythonEdb",
            Router: `/edb_info/python/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "GetPythonEdbCode",
            Router: `/edb_info/python/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "EditPythonEdb",
            Router: `/edb_info/python/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ExecPythonCode",
            Router: `/edb_info/python/exec`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoReplace",
            Router: `/edb_info/replace`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphConfigSaveChart",
            Router: `/multiple_graph/chart/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "GetMultipleGraphConfig",
            Router: `/multiple_graph/config/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphConfigSave",
            Router: `/multiple_graph/config/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphConfigSaveEdb",
            Router: `/multiple_graph/edb/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphPreview",
            Router: `/multiple_graph/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphPreviewCurve",
            Router: `/multiple_graph/preview_cure`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/chart/theme/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/chart/theme/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/chart/theme/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/chart/theme/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"],
        beego.ControllerComments{
            Method: "ListBySource",
            Router: `/chart/theme/list_by_source`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"],
        beego.ControllerComments{
            Method: "GetThemePreviewData",
            Router: `/chart/theme/preview_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"],
        beego.ControllerComments{
            Method: "SetDefaultTheme",
            Router: `/chart/theme/set_default`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"],
        beego.ControllerComments{
            Method: "TypeList",
            Router: `/chart/theme/type/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ChartThemeController"],
        beego.ControllerComments{
            Method: "TypeListBySource",
            Router: `/chart/theme/type/list_by_source`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "AddEdbClassify",
            Router: `/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "DeleteEdbClassify",
            Router: `/classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "DeleteEdbClassifyCheck",
            Router: `/classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "ClassifyEdbInfoList",
            Router: `/classify/edb_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "EditEdbClassify",
            Router: `/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "Items",
            Router: `/classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "ItemsV2",
            Router: `/classify/items/v2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "ItemsV3",
            Router: `/classify/items/v3`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "ListV2",
            Router: `/classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "SimpleList",
            Router: `/classify/simple`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "ClassifyTree",
            Router: `/classify/tree`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "EdbClassifyMove",
            Router: `/edb_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "AddMysteelChemical",
            Router: `/mysteel_chemical/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "AddMysteelChemicalClassify",
            Router: `/mysteel_chemical/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "DeleteMysteelChemicalClassify",
            Router: `/mysteel_chemical/classify/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "EditMysteelChemicalClassify",
            Router: `/mysteel_chemical/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "MoveMysteelChemicalClassify",
            Router: `/mysteel_chemical/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "DeleteMysteelChemical",
            Router: `/mysteel_chemical/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "EditMysteelChemical",
            Router: `/mysteel_chemical/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "MysteelChemicalExport",
            Router: `/mysteel_chemical/export/dataList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "MoveMysteelChemical",
            Router: `/mysteel_chemical/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BaiinfoClassify",
            Router: `/baiinfo/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "AddBaiinfoClassify",
            Router: `/baiinfo/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DeleteBaiinfoClassify",
            Router: `/baiinfo/classify/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EditBaiinfoClassify",
            Router: `/baiinfo/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveBaiinfoClassify",
            Router: `/baiinfo/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BaiinfoClassifyName",
            Router: `/baiinfo/classify/name`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BaiinfoData",
            Router: `/baiinfo/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DeleteBaiinfoData",
            Router: `/baiinfo/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EditBaiinfo",
            Router: `/baiinfo/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BaiinfoFrequency",
            Router: `/baiinfo/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveBaiinfoData",
            Router: `/baiinfo/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ResetBaiinfoData",
            Router: `/baiinfo/reset`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BaiinfoSearchList",
            Router: `/baiinfo/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BaiinfoSingleData",
            Router: `/baiinfo/single_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BatchChartInfoRefresh",
            Router: `/chart_info/batch_refresh`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GetBatchChartRefreshResult",
            Router: `/chart_info/batch_refresh/result`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoRefresh",
            Router: `/chart_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ComTradeCountryList",
            Router: `/com_trade/country/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ComTradeDataList",
            Router: `/com_trade/data/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ComTradeList",
            Router: `/com_trade/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbChartAdminList",
            Router: `/edb_chart/adminList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveEdbChartUser",
            Router: `/edb_chart/change_user`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbChartClassifyList",
            Router: `/edb_chart/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveEdbChartList",
            Router: `/edb_chart/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "QueryEdbDataTable",
            Router: `/edb_data/table/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoAdd",
            Router: `/edb_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoBatchAdd",
            Router: `/edb_info/batch/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbChartList",
            Router: `/edb_info/chart/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GetEdbDateData",
            Router: `/edb_info/date_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GetEdbBeforeAndAfterDateData",
            Router: `/edb_info/date_data/before_after`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoDetail",
            Router: `/edb_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoEdit",
            Router: `/edb_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbEnInfoEdit",
            Router: `/edb_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoExistCheck",
            Router: `/edb_info/exist/check`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoFilter",
            Router: `/edb_info/filter`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoFilterByEs",
            Router: `/edb_info/filter_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "AllEdbInfoByEs",
            Router: `/edb_info/filter_by_es/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ChartImageSet",
            Router: `/edb_info/image/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SetEdbDataInsertConfig",
            Router: `/edb_info/insert_config/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoList",
            Router: `/edb_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "Modify",
            Router: `/edb_info/modify`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoMove",
            Router: `/edb_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoNewest",
            Router: `/edb_info/newest`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoRefresh",
            Router: `/edb_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoAllRefresh",
            Router: `/edb_info/refresh/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "RefreshClassifyList",
            Router: `/edb_info/refresh/classify_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SaveEdbRefreshConfig",
            Router: `/edb_info/refresh/config/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GetEdbRefreshDefaultConfig",
            Router: `/edb_info/refresh/default_config`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SaveEdbRefreshDefaultConfig",
            Router: `/edb_info/refresh/default_config/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GetEdbRefreshEdbConfig",
            Router: `/edb_info/refresh/edb_config`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "RefreshEdbList",
            Router: `/edb_info/refresh/edb_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "RefreshSourceList",
            Router: `/edb_info/refresh/source_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SaveEdbRefreshStatus",
            Router: `/edb_info/refresh/status/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "RelationChartList",
            Router: `/edb_info/relation/chart_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "RelationEdbList",
            Router: `/edb_info/relation/edbinfo_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoReplaceCheck",
            Router: `/edb_info/replace/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoSearch",
            Router: `/edb_info/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmEdbInfoBatchAdd",
            Router: `/edb_info/smm/batch/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmExistCheck",
            Router: `/edb_info/smm/exist/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoSmmSearch",
            Router: `/edb_info/smm/search`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "TraceEdbInfo",
            Router: `/edb_info/trace`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoUpdates",
            Router: `/edb_info/updates`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoUpdatesCheck",
            Router: `/edb_info/updates/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoUpdatesList",
            Router: `/edb_info/updates/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoUpdatesStatistical",
            Router: `/edb_info/updates/statistical`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BatchAddNoPermissionAdmin",
            Router: `/edb_no_permission/batch_add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DelNoPermissionAdmin",
            Router: `/edb_no_permission/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbNoPermissionList",
            Router: `/edb_no_permission/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ModifyNoPermissionAdmin",
            Router: `/edb_no_permission/modify`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbSourceList",
            Router: `/edb_source/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbSourceListByPython",
            Router: `/edb_source/list/python`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EiaSteoClassify",
            Router: `/eia_steo/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EiaSteoData",
            Router: `/eia_steo/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EiaSteoSearchList",
            Router: `/eia_steo/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportBaiinfoList",
            Router: `/export/baiinfoList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportGlList",
            Router: `/export/glList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportLzList",
            Router: `/export/lzList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportLzQuotasData",
            Router: `/export/lzQuotasData`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportSciList",
            Router: `/export/sciList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportSmmList",
            Router: `/export/smmList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "FenweiClassify",
            Router: `/fenwei/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportFenweiList",
            Router: `/fenwei/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "FenweiIndexData",
            Router: `/fenwei/index/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "FenweiSearchList",
            Router: `/fenwei/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "FenweiSingleData",
            Router: `/fenwei/single_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GlClassify",
            Router: `/gl/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GlData",
            Router: `/gl/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GlFrequency",
            Router: `/gl/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GlSearchList",
            Router: `/gl/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GlSingleData",
            Router: `/gl/single_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "LzClassify",
            Router: `/lz/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "LzData",
            Router: `/lz/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "LzFrequency",
            Router: `/lz/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "LzSearchList",
            Router: `/lz/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalClassify",
            Router: `/mysteel_chemical/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalData",
            Router: `/mysteel_chemical/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalDetail",
            Router: `/mysteel_chemical/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalFrequency",
            Router: `/mysteel_chemical/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalIndexList",
            Router: `/mysteel_chemical/index/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalRefresh",
            Router: `/mysteel_chemical/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalSearch",
            Router: `/mysteel_chemical/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SciClassify",
            Router: `/sci/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "AddSciClassify",
            Router: `/sci/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DeleteSciClassify",
            Router: `/sci/classify/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EditSciClassify",
            Router: `/sci/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveSciClassify",
            Router: `/sci/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SciClassifyName",
            Router: `/sci/classify/name`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SciData",
            Router: `/sci/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DeleteSciData",
            Router: `/sci/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EditSci",
            Router: `/sci/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SciFrequency",
            Router: `/sci/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveSciData",
            Router: `/sci/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ResetSciData",
            Router: `/sci/reset`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SciSearchList",
            Router: `/sci/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SciSingleData",
            Router: `/sci/single_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmApiList",
            Router: `/smm/api/list`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmApiTypeList",
            Router: `/smm/api/type/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmClassify",
            Router: `/smm/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "AddSmmClassify",
            Router: `/smm/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DeleteSmmClassify",
            Router: `/smm/classify/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EditSmmClassify",
            Router: `/smm/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveSmmClassify",
            Router: `/smm/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmClassifyName",
            Router: `/smm/classify/name`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmData",
            Router: `/smm/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DeleteSmmData",
            Router: `/smm/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EditSmm",
            Router: `/smm/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmFrequency",
            Router: `/smm/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmIndexList",
            Router: `/smm/index/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveSmmData",
            Router: `/smm/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ResetSmmData",
            Router: `/smm/reset`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmSearchList",
            Router: `/smm/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmSingleData",
            Router: `/smm/single_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "YongyiClassify",
            Router: `/yongyi/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportYongyiList",
            Router: `/yongyi/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "YongyiIndexData",
            Router: `/yongyi/index/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "YongyiSearchList",
            Router: `/yongyi/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "YongyiSingleData",
            Router: `/yongyi/single_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:JiaYueEdbSourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:JiaYueEdbSourceController"],
        beego.ControllerComments{
            Method: "FrequencyList",
            Router: `/edb_source/jiayue/frequency_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:JiaYueEdbSourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:JiaYueEdbSourceController"],
        beego.ControllerComments{
            Method: "IndexPageList",
            Router: `/edb_source/jiayue/index_page_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:JiaYueEdbSourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:JiaYueEdbSourceController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/edb_source/jiayue/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "ClassifyList",
            Router: `/manual/classify/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "AllClassifyList",
            Router: `/manual/classify/all_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "FirstClassifyList",
            Router: `/manual/classify/first`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "ManualSetClassifyAll",
            Router: `/manual/set_classify/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "ManualSysUserAll",
            Router: `/manual/sysuser/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "ManualSysUserClassifySave",
            Router: `/manual/sysuser/classify/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "ManualSysUserSearch",
            Router: `/manual/sysuser/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartAdd",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartAddToClassify",
            Router: `/add_to_classify`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ChartList",
            Router: `/chart/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ChartRecommendList",
            Router: `/chart/recommend/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ClassifyAdd",
            Router: `/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "CompanyPublicClassifyList",
            Router: `/classify/company_public_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "CopyClassifyAndChart",
            Router: `/classify/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ClassifyDelete",
            Router: `/classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ClassifyEdit",
            Router: `/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ClassifyFrameworkNodeList",
            Router: `/classify/framework_node_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ClassifyList",
            Router: `/classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ModifyClassifyCompanyPublicStatus",
            Router: `/classify/modify_company_public`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ModifyClassifyPublicStatus",
            Router: `/classify/modify_public`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ClassifyMove",
            Router: `/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "PublicClassifyList",
            Router: `/classify/public_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartDelete",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartEdit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "GetMyChartClassifyIdList",
            Router: `/get_mychart_classify_id_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartList",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartMove",
            Router: `/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartSearch",
            Router: `/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartSearchByEs",
            Router: `/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/predict_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/predict_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "DeleteCheck",
            Router: `/predict_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/predict_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "Items",
            Router: `/predict_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/predict_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "ListV2",
            Router: `/predict_classify/list/v2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/predict_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "SimpleList",
            Router: `/predict_classify/simple`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "ClassifyTree",
            Router: `/predict_classify/tree`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/predict_edb_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "CalculateBatchSave",
            Router: `/predict_edb_info/calculate/batch/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "BatchCalculateBatchSave",
            Router: `/predict_edb_info/calculate/batch/save/batch`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "CalculateComputeCorrelation",
            Router: `/predict_edb_info/calculate/compute_correlation`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "CalculateSave",
            Router: `/predict_edb_info/calculate/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "ChartDataList",
            Router: `/predict_edb_info/chart/data/list`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "EdbChartList",
            Router: `/predict_edb_info/chart/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "DataList",
            Router: `/predict_edb_info/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/predict_edb_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/predict_edb_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "FilterByEs",
            Router: `/predict_edb_info/filter_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "ChartImageSet",
            Router: `/predict_edb_info/image/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "ClassifyEdbInfoItems",
            Router: `/predict_edb_info/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/predict_edb_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "Modify",
            Router: `/predict_edb_info/modify`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/predict_edb_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "Refresh",
            Router: `/predict_edb_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "RefreshAll",
            Router: `/predict_edb_info/refresh/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "PredictRuleCalculateByNine",
            Router: `/predict_edb_info/rule/calculate_by_nine`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"],
        beego.ControllerComments{
            Method: "GfexClassifyList",
            Router: `/gfex/classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"],
        beego.ControllerComments{
            Method: "GfexContract",
            Router: `/gfex/contract`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"],
        beego.ControllerComments{
            Method: "GfexIndexDetail",
            Router: `/gfex/index/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"],
        beego.ControllerComments{
            Method: "ExportGfexIndexDetail",
            Router: `/gfex/index/detail/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"],
        beego.ControllerComments{
            Method: "GfexIndexData",
            Router: `/gfex/index_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"],
        beego.ControllerComments{
            Method: "GfexMaxDate",
            Router: `/gfex/max/date`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"],
        beego.ControllerComments{
            Method: "IcpiClassifyList",
            Router: `/icpi/classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"],
        beego.ControllerComments{
            Method: "ExportIcpiDataList",
            Router: `/icpi/export/icpiDataList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_source:DataSourceController"],
        beego.ControllerComments{
            Method: "IcpiData",
            Router: `/icpi/index/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"],
        beego.ControllerComments{
            Method: "EdbDeleteLog",
            Router: `/edb_delete_log`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"],
        beego.ControllerComments{
            Method: "EdbUpdateLog",
            Router: `/edb_update_log`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"],
        beego.ControllerComments{
            Method: "EdbUpdateStat",
            Router: `/edb_update_stat`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"],
        beego.ControllerComments{
            Method: "EdbUpdateFailedList",
            Router: `/edb_update_stat/failed`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"],
        beego.ControllerComments{
            Method: "EdbUpdateFailedDetailList",
            Router: `/edb_update_stat/failed/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"],
        beego.ControllerComments{
            Method: "Column",
            Router: `/source_column`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"],
        beego.ControllerComments{
            Method: "EditColumn",
            Router: `/source_column/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbSourceStatController"],
        beego.ControllerComments{
            Method: "EdbSourceStat",
            Router: `/source_stat`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbTerminalController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbTerminalController"],
        beego.ControllerComments{
            Method: "TerminalCodeList",
            Router: `/terminal/code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbTerminalController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbTerminalController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/terminal/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbTerminalController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbTerminalController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/terminal/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbTerminalController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/data_stat:EdbTerminalController"],
        beego.ControllerComments{
            Method: "SetStatus",
            Router: `/terminal/status/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnPermissionController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnPermissionController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnPermissionController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnPermissionController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnPermissionController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnPermissionController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnPermissionController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnPermissionController"],
        beego.ControllerComments{
            Method: "ParentList",
            Router: `/parent/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnPermissionController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnPermissionController"],
        beego.ControllerComments{
            Method: "Remove",
            Router: `/remove`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishAuthController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishAuthController"],
        beego.ControllerComments{
            Method: "BatchAdd",
            Router: `/auth/batch_add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishAuthController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishAuthController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/auth/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishAuthController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishAuthController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/auth/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishAuthController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishAuthController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/auth/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishAuthController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishAuthController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/auth/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishClassifyController"],
        beego.ControllerComments{
            Method: "PermissionEdit",
            Router: `/permission/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/company/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/company/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "EditEnabled",
            Router: `/company/edit_enabled`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/company/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/company/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "SavePermission",
            Router: `/company/save_permission`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "ViewList",
            Router: `/company/view_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/company_todo/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "AddPublic",
            Router: `/company_todo/add_public`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "Approve",
            Router: `/company_todo/approve`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "DoingList",
            Router: `/company_todo/doing_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/company_todo/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "EditList",
            Router: `/company_todo/edit_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "LastPublicTodo",
            Router: `/company_todo/last_public_todo`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/company_todo/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishPolicyReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishPolicyReportController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/policy/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishPolicyReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishPolicyReportController"],
        beego.ControllerComments{
            Method: "ListReport",
            Router: `/policy/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishPolicyReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishPolicyReportController"],
        beego.ControllerComments{
            Method: "PullPolicyData",
            Router: `/policy/pull`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishPolicyReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishPolicyReportController"],
        beego.ControllerComments{
            Method: "SyncReport",
            Router: `/policy/sync`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "CancelApprove",
            Router: `/approve/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "SubmitApprove",
            Router: `/approve/submit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "Author",
            Router: `/author`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "AddClassify",
            Router: `/classify/add`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "DelClassify",
            Router: `/classify/delete`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "EditClassify",
            Router: `/classify/edit`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "FistListClassify",
            Router: `/classify/first/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "ListClassify",
            Router: `/classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "ClassifyIdDetail",
            Router: `/classifyIdDetail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "EditPolicy",
            Router: `/edit_policy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "ListReport",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "MarkEditStatus",
            Router: `/mark`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "PrePublishReport",
            Router: `/pre_publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "PublishReport",
            Router: `/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "PublishCancleReport",
            Router: `/publish/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "SaveReportContent",
            Router: `/saveReportContent`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailCallBackController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailCallBackController"],
        beego.ControllerComments{
            Method: "SendCallBack",
            Router: `/email/send/call_back`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/email/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "EditEnabled",
            Router: `/email/editEnabled`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "ImportListMatch",
            Router: `/email/import`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/email/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "LogList",
            Router: `/email/log_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "MoveToCurrent",
            Router: `/email/moveToCurrent`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "PvList",
            Router: `/email/pv_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "Resend",
            Router: `/email/resend`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/email/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "Send",
            Router: `/email/send`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "VideoResend",
            Router: `/email/video/resend`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "VideoSend",
            Router: `/email/video/send`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "ViewList",
            Router: `/email/view_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "CoverDelete",
            Router: `/video/cover/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "CoverList",
            Router: `/video/cover/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "CoverSave",
            Router: `/video/cover/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/video/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/video/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/video/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "PublishVideo",
            Router: `/video/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "PublishCancleVideo",
            Router: `/video/publish/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/video/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/eta_trial:EtaTrialController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/eta_trial:EtaTrialController"],
        beego.ControllerComments{
            Method: "QuestionnaireCommit",
            Router: `/questionnaire/commit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/eta_trial:EtaTrialController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/eta_trial:EtaTrialController"],
        beego.ControllerComments{
            Method: "QuestionnairePopUp",
            Router: `/questionnaire/popup`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/eta_trial:EtaTrialController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/eta_trial:EtaTrialController"],
        beego.ControllerComments{
            Method: "UpdateActiveTime",
            Router: `/user/active`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/eta_trial:EtaTrialController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/eta_trial:EtaTrialController"],
        beego.ControllerComments{
            Method: "UpdateLoginDuration",
            Router: `/user/login_duration`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"],
        beego.ControllerComments{
            Method: "Approve",
            Router: `/approve`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"],
        beego.ControllerComments{
            Method: "Cancel",
            Router: `/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"],
        beego.ControllerComments{
            Method: "CheckApproveOpen",
            Router: `/classify/check_open`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"],
        beego.ControllerComments{
            Method: "MessageList",
            Router: `/message/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"],
        beego.ControllerComments{
            Method: "MessageRead",
            Router: `/message/read`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveController"],
        beego.ControllerComments{
            Method: "Refuse",
            Router: `/refuse`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveFlowController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveFlowController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/flow/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveFlowController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveFlowController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/flow/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveFlowController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveFlowController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/flow/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveFlowController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveFlowController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/flow/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveFlowController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveFlowController"],
        beego.ControllerComments{
            Method: "Remove",
            Router: `/flow/remove`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveFlowController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/report_approve:ReportApproveFlowController"],
        beego.ControllerComments{
            Method: "ReportClassifyTree",
            Router: `/report/classify_tree`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "ResearcherList",
            Router: `/researcher/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "AddSandboxClassify",
            Router: `/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "DeleteSandboxClassify",
            Router: `/classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "DeleteSandboxClassifyCheck",
            Router: `/classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "EditSandboxClassify",
            Router: `/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "SandboxClassifyItems",
            Router: `/classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "ChartClassifyMove",
            Router: `/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "SandboxClassifyList",
            Router: `/classifyList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "DeleteV2",
            Router: `/deleteV2`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "GetSandboxDetail",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "AddSandboxDraft",
            Router: `/draft/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "GetLastSandboxInfo",
            Router: `/last_info`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "LinkEdbInfoCheck",
            Router: `/link/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "ListV2",
            Router: `/listV2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "ListByQuote",
            Router: `/list_by_quote`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "MarkEditStatus",
            Router: `/mark`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "SaveV2",
            Router: `/saveV2`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "GetSandboxVersionDetail",
            Router: `/version/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "FirstVersionList",
            Router: `/version/first_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/sandbox:SandboxController"],
        beego.ControllerComments{
            Method: "VersionList",
            Router: `/version/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareClassifyController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/compare_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareClassifyController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/compare_classify/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareClassifyController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/compare_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareClassifyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/compare_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/compare/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/compare/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/compare/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"],
        beego.ControllerComments{
            Method: "PageList",
            Router: `/compare/page_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/compare/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"],
        beego.ControllerComments{
            Method: "SaveKeywords",
            Router: `/compare/save_keywords`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"],
        beego.ControllerComments{
            Method: "Search",
            Router: `/compare/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"],
        beego.ControllerComments{
            Method: "SelectDocs",
            Router: `/compare/select_docs`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaCompareController"],
        beego.ControllerComments{
            Method: "UpdateResultImg",
            Router: `/compare/update_result_img`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocClassifyController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/doc_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocClassifyController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/doc_classify/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocClassifyController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/doc_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocClassifyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/doc_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/doc/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/doc/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/doc/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/doc/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/doc/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaDocController"],
        beego.ControllerComments{
            Method: "PageList",
            Router: `/doc/page_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaLabelController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaLabelController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/label/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaLabelController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaLabelController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/label/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaLabelController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaLabelController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/label/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaLabelController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaLabelController"],
        beego.ControllerComments{
            Method: "PageList",
            Router: `/label/page_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaLabelController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/semantic_analysis:SaLabelController"],
        beego.ControllerComments{
            Method: "UseDetail",
            Router: `/label/use_detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "CancelApprove",
            Router: `/approve/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "SubmitApprove",
            Router: `/approve/submit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "DetailImg",
            Router: `/detail_img`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "LastPublishedReport",
            Router: `/last_published_report`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "MarkEditStatus",
            Router: `/mark_edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "PrePublish",
            Router: `/pre_publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "Publish",
            Router: `/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "Remove",
            Router: `/remove`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "SaveContent",
            Router: `/save_content`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "SendMsg",
            Router: `/send_msg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportController"],
        beego.ControllerComments{
            Method: "VoiceUpload",
            Router: `/voice_upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportResourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportResourceController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/resource/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportResourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportResourceController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/resource/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportResourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportResourceController"],
        beego.ControllerComments{
            Method: "Remove",
            Router: `/resource/remove`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportResourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/smart_report:SmartReportResourceController"],
        beego.ControllerComments{
            Method: "Rename",
            Router: `/resource/rename`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/trade_analysis:TradeAnalysisController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/trade_analysis:TradeAnalysisController"],
        beego.ControllerComments{
            Method: "GetClassifyName",
            Router: `/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers/trade_analysis:TradeAnalysisController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers/trade_analysis:TradeAnalysisController"],
        beego.ControllerComments{
            Method: "GetPositionTop",
            Router: `/top`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:BannerController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:BannerController"],
        beego.ControllerComments{
            Method: "Upload",
            Router: `/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:BusinessConfController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:BusinessConfController"],
        beego.ControllerComments{
            Method: "Fetch",
            Router: `/fetch`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:BusinessConfController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:BusinessConfController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:BusinessConfOpenController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:BusinessConfOpenController"],
        beego.ControllerComments{
            Method: "CodeEncrypt",
            Router: `/code_encrypt`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "CheckDeleteClassify",
            Router: `/checkDeleteClassify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "FindByIdClassify",
            Router: `/findById`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "ListClassify",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "ParentClassify",
            Router: `/parent`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "EditClassifyPermission",
            Router: `/permission/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "ClassifyPermission",
            Router: `/permission_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "TelListClassify",
            Router: `/tel_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"],
        beego.ControllerComments{
            Method: "BatchDelete",
            Router: `/batch_delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"],
        beego.ControllerComments{
            Method: "MenuCreate",
            Router: `/menu/create`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"],
        beego.ControllerComments{
            Method: "MenuDelete",
            Router: `/menu/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"],
        beego.ControllerComments{
            Method: "MenuDownload",
            Router: `/menu/download`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"],
        beego.ControllerComments{
            Method: "MenuRename",
            Router: `/menu/rename`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"],
        beego.ControllerComments{
            Method: "MenuResources",
            Router: `/menu/resources`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"],
        beego.ControllerComments{
            Method: "MenuTree",
            Router: `/menu/tree`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"],
        beego.ControllerComments{
            Method: "CheckResourceRepeat",
            Router: `/resource/check_repeat`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"],
        beego.ControllerComments{
            Method: "ResourceDelete",
            Router: `/resource/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"],
        beego.ControllerComments{
            Method: "ResourceRename",
            Router: `/resource/rename`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CloudDiskController"],
        beego.ControllerComments{
            Method: "ResourceUpload",
            Router: `/resource/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CompanyPermissionController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CompanyPermissionController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/permission/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CompanyPermissionController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CompanyPermissionController"],
        beego.ControllerComments{
            Method: "PermissionVariety",
            Router: `/permission/variety`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:CompanySellerController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:CompanySellerController"],
        beego.ControllerComments{
            Method: "CheckListV2",
            Router: `/seller/check/listV2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:MeetingProbabilitiesController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:MeetingProbabilitiesController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:OutLinkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:OutLinkController"],
        beego.ControllerComments{
            Method: "AllList",
            Router: `/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:OutLinkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:OutLinkController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:OutLinkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:OutLinkController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:OutLinkController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:OutLinkController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PdfToImgCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PdfToImgCommonController"],
        beego.ControllerComments{
            Method: "PdfToImgConvert",
            Router: `/convert`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishCommonController"],
        beego.ControllerComments{
            Method: "DownloadPptx",
            Router: `/downloadpptx`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "AddPpt",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "GetConfig",
            Router: `/config`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "DeletePpt",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "DetailPpt",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "EditPpt",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "Editing",
            Router: `/editing`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "Grant",
            Router: `/grant`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "CancelGrant",
            Router: `/grant/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "GrantInfo",
            Router: `/grant/info`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "ListPpt",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "PptUpload",
            Router: `/pptUpload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "Publish",
            Router: `/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "SaveLog",
            Router: `/saveLog`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "TitleCheck",
            Router: `/titleCheck`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishController"],
        beego.ControllerComments{
            Method: "ToReport",
            Router: `/toReport`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "CopyPpt",
            Router: `/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "GrantPptList",
            Router: `/grant/ppt/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "AddGroup",
            Router: `/group/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "CopyGroup",
            Router: `/group/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "DeleteGroup",
            Router: `/group/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "MoveGroup",
            Router: `/group/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "GroupNameList",
            Router: `/group/name`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "GroupPptList",
            Router: `/group/ppt/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "SearchGroupPptList",
            Router: `/group/ppt/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "RenameGroup",
            Router: `/group/rename`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "ShareGroup",
            Router: `/group/share`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "GroupList",
            Router: `/groups`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "MoveGroupPpt",
            Router: `/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "ListSearch",
            Router: `/ppt/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "SharePpt",
            Router: `/share`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptEnglishGroupController"],
        beego.ControllerComments{
            Method: "SharePptList",
            Router: `/share/ppt/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2CommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2CommonController"],
        beego.ControllerComments{
            Method: "DownloadPptx",
            Router: `/downloadpptx`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "AddPpt",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "BatchToEn",
            Router: `/batchToEn`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "GetConfig",
            Router: `/config`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "DeletePpt",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "DetailPpt",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "EditPpt",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "Editing",
            Router: `/editing`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "Grant",
            Router: `/grant`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "CancelGrant",
            Router: `/grant/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "GrantInfo",
            Router: `/grant/info`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "ListPpt",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "PptUpload",
            Router: `/pptUpload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "Publish",
            Router: `/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "SaveLog",
            Router: `/saveLog`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "TitleCheck",
            Router: `/titleCheck`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "ToEn",
            Router: `/toEn`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2Controller"],
        beego.ControllerComments{
            Method: "ToReport",
            Router: `/to_report`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "CopyPpt",
            Router: `/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "GrantPptList",
            Router: `/grant/ppt/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "AddGroup",
            Router: `/group/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "CopyGroup",
            Router: `/group/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "DeleteGroup",
            Router: `/group/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "MoveGroup",
            Router: `/group/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "GroupNameList",
            Router: `/group/name`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "GroupPptList",
            Router: `/group/ppt/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "SearchGroupPptList",
            Router: `/group/ppt/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "RenameGroup",
            Router: `/group/rename`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "ShareGroup",
            Router: `/group/share`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "GroupList",
            Router: `/groups`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "MoveGroupPpt",
            Router: `/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "ListSearch",
            Router: `/ppt/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "SharePpt",
            Router: `/share`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:PptV2GroupController"],
        beego.ControllerComments{
            Method: "SharePptList",
            Router: `/share/ppt/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportAuthorController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportAuthorController"],
        beego.ControllerComments{
            Method: "Author",
            Router: `/author`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportAuthorController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportAuthorController"],
        beego.ControllerComments{
            Method: "AddAuthor",
            Router: `/author/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportAuthorController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportAuthorController"],
        beego.ControllerComments{
            Method: "DeleteAuthor",
            Router: `/author/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportAuthorController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportAuthorController"],
        beego.ControllerComments{
            Method: "EditAuthor",
            Router: `/author/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportAuthorController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportAuthorController"],
        beego.ControllerComments{
            Method: "EnableAuthor",
            Router: `/author/enable`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportChapterTypeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportChapterTypeController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/chapter_type/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportChapterTypeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportChapterTypeController"],
        beego.ControllerComments{
            Method: "AuthSetting",
            Router: `/chapter_type/auth_setting`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportChapterTypeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportChapterTypeController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/chapter_type/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportChapterTypeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportChapterTypeController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/chapter_type/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportChapterTypeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportChapterTypeController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/chapter_type/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportChapterTypeController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportChapterTypeController"],
        beego.ControllerComments{
            Method: "PermissionList",
            Router: `/chapter_type/permission_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "CheckDayWeekReportChapterVideo",
            Router: `/CheckDayWeekReportChapterVideo`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "AddDayWeekReport",
            Router: `/addDayWeekReport`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "CancelApprove",
            Router: `/approve/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "SubmitApprove",
            Router: `/approve/submit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "Author",
            Router: `/author`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "ClassifyIdDetail",
            Router: `/classifyIdDetail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "EditChapterTrendTag",
            Router: `/editChapterTrendTag`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "EditDayWeekChapter",
            Router: `/editDayWeekChapter`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "EditDayWeekReport",
            Router: `/editDayWeekReport`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetChapterTrendTag",
            Router: `/getChapterTrendTag`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetDayReportTickerList",
            Router: `/getDayReportTickerList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetDayWeekChapter",
            Router: `/getDayWeekChapter`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetDayWeekReportChapterTypeList",
            Router: `/getDayWeekReportChapterTypeList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetDayWeekReportPauseTime",
            Router: `/getDayWeekReportPauseTime`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetDayWeekReportVideoList",
            Router: `/getDayWeekReportVideoList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetLastDayWeekReportChapter",
            Router: `/getLastDayWeekReportChapter`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetReportChapterList",
            Router: `/getReportChapterList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetStopDayWeekReportChapterTypeList",
            Router: `/getStopDayWeekReportChapterTypeList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetSunCode",
            Router: `/getSunCode`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "IsLastDayWeekReportChapter",
            Router: `/isLastDayWeekReportChapter`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "ListReport",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "MarkEditStatus",
            Router: `/mark`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "PrePublishReport",
            Router: `/pre_publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "PublishReport",
            Router: `/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "PublishCancleReport",
            Router: `/publish/cancle`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "PublishDayWeekReport",
            Router: `/publishDayWeekReport`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "PublishDayWeekReportChapter",
            Router: `/publishDayWeekReportChapter`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "Export",
            Router: `/report_view_record/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "SaveReportContent",
            Router: `/saveReportContent`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "SendMsg",
            Router: `/sendMsg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "SendTemplateMsg",
            Router: `/sendTemplateMsg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "SetDayWeekReportEnableRule",
            Router: `/setDayWeekReportEnableUpdateRule`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "SetDayWeekReportUpdateRule",
            Router: `/setDayWeekReportUpdateRule`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "ThsSendTemplateMsg",
            Router: `/ths/sendTemplateMsg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "Upload",
            Router: `/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ReportUploadCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ReportUploadCommonController"],
        beego.ControllerComments{
            Method: "UploadImg",
            Router: `/uploadImg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ResearchGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ResearchGroupController"],
        beego.ControllerComments{
            Method: "GetAdminResearchGroup",
            Router: `/research_group/admin_group`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ResearchGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ResearchGroupController"],
        beego.ControllerComments{
            Method: "GetResearchGroupList",
            Router: `/research_group/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ResourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ResourceController"],
        beego.ControllerComments{
            Method: "Upload",
            Router: `/image/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ResourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ResourceController"],
        beego.ControllerComments{
            Method: "UploadV2",
            Router: `/image/uploadV2`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ResourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ResourceController"],
        beego.ControllerComments{
            Method: "OssSTSToken",
            Router: `/oss/get_sts_token`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ResourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ResourceController"],
        beego.ControllerComments{
            Method: "UploadImageBase64",
            Router: `/upload_image_base64`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ResourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ResourceController"],
        beego.ControllerComments{
            Method: "VideoUpload",
            Router: `/video/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:ResourceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:ResourceController"],
        beego.ControllerComments{
            Method: "VoiceUpload",
            Router: `/voice/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/sysuser/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "SetConfig",
            Router: `/sysuser/config/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/sysuser/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/sysuser/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/sysuser/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "EditEnabled",
            Router: `/sysuser/editEnabled`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "ListSysuser",
            Router: `/sysuser/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/sysuser/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "ResetPass",
            Router: `/sysuser/reset_pass`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysDepartmentController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysDepartmentController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/department/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysDepartmentController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysDepartmentController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/department/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysDepartmentController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysDepartmentController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/department/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysDepartmentController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysDepartmentController"],
        beego.ControllerComments{
            Method: "ListDepartment",
            Router: `/department/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysGroupController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/group/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysGroupController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/group/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysGroupController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/group/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysGroupController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysGroupController"],
        beego.ControllerComments{
            Method: "SetSort",
            Router: `/group/set_sort`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleAdminController"],
        beego.ControllerComments{
            Method: "AddAdmin",
            Router: `/role/admin/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleAdminController"],
        beego.ControllerComments{
            Method: "DeleteAdmin",
            Router: `/role/admin/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleAdminController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/role/admin/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleAdminController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleAdminController"],
        beego.ControllerComments{
            Method: "SellerList",
            Router: `/role/seller/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "SystemConfig",
            Router: `/config`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "SysMenuButtons",
            Router: `/menu/buttons`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "SysMenuList",
            Router: `/menu/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/role/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "AllSysRole",
            Router: `/role/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/role/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/role/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "ListSysRole",
            Router: `/role/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "SysRoleMenusAdd",
            Router: `/role/menu/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "SysRoleMenuAuthList",
            Router: `/role/menu/auth_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "SysRoleMenuAuthSave",
            Router: `/role/menu/auth_save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "ButtonList",
            Router: `/role/menu/buttons`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "SysRoleMenusList",
            Router: `/role/menu/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysTeamController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysTeamController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/team/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysTeamController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysTeamController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/team/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysTeamController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysTeamController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/team/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysUserAuthController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysUserAuthController"],
        beego.ControllerComments{
            Method: "CheckPwd",
            Router: `/check_pwd`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysUserAuthController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysUserAuthController"],
        beego.ControllerComments{
            Method: "GetCrmAuthCode",
            Router: `/get_crm_auth_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysUserAuthController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysUserAuthController"],
        beego.ControllerComments{
            Method: "ModifyPwd",
            Router: `/modify/pwd`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysUserController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysUserController"],
        beego.ControllerComments{
            Method: "AuthCodeLogin",
            Router: `/auth_code_login`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysUserController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysUserController"],
        beego.ControllerComments{
            Method: "Login",
            Router: `/login`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:SysUserController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:SysUserController"],
        beego.ControllerComments{
            Method: "Uuid",
            Router: `/uuid`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetCommonController"],
        beego.ControllerComments{
            Method: "DataList",
            Router: `/dataList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetCommonController"],
        beego.ControllerComments{
            Method: "ExportLongzhong",
            Router: `/export/longzhong`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetCommonController"],
        beego.ControllerComments{
            Method: "ExportLongzhongPrice",
            Router: `/export/longzhong/price`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetCommonController"],
        beego.ControllerComments{
            Method: "ExportLongzhongSurvey",
            Router: `/export/longzhong/survey`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetCommonController"],
        beego.ControllerComments{
            Method: "EdbTemplateDownload",
            Router: `/target/template`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetCommonController"],
        beego.ControllerComments{
            Method: "TemplateDownload",
            Router: `/template`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "ClassifyList",
            Router: `/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "DataAdd",
            Router: `/data/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "BatchDataDeleteByTradeCode",
            Router: `/data/batch_delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "BatchDataDeleteByDate",
            Router: `/data/batch_delete_by_date`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "BatchDataEdit",
            Router: `/data/batch_edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "DataCheck",
            Router: `/data/check`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "DataDelete",
            Router: `/data/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "DataEdit",
            Router: `/data/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "DataList",
            Router: `/data/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "ExportDataList",
            Router: `/export/dataList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "GetResearcher",
            Router: `/getResearcher`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "GetTargetItems",
            Router: `/getTargetItems`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "ImportData",
            Router: `/import/data`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "ImportFailListDownload",
            Router: `/import/failList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "ImportTargetFailListDownload",
            Router: `/import_target/failList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "TargetAdd",
            Router: `/target/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "TargetCheck",
            Router: `/target/check`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "TargetDelete",
            Router: `/target/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "TargetEdit",
            Router: `/target/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "ExcelDataAdd",
            Router: `/target/excel_style/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "ExcelDataEdit",
            Router: `/target/excel_style/edit`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "TargetFrequencyList",
            Router: `/target/frequency_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "ImportTarget",
            Router: `/target/import`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "TargetItemList",
            Router: `/target/item_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "TargetItemNameList",
            Router: `/target/item_name_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "TargetList",
            Router: `/target/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "TargetSearch",
            Router: `/target/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TargetController"],
        beego.ControllerComments{
            Method: "TargetUnitList",
            Router: `/target/unit_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "CffexDataList",
            Router: `/data/cffex`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "CoalMineClassify",
            Router: `/data/coalMineData/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "CoalMineData",
            Router: `/data/coalMineData/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "CoalMineFrequency",
            Router: `/data/coalMineData/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "CoalSearchList",
            Router: `/data/coalMineData/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "CoalSingleData",
            Router: `/data/coalMineData/single_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "DalianDataList",
            Router: `/data/dalian`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "EicContinentList",
            Router: `/data/eicContinent`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "EicContinentListV2",
            Router: `/data/eicContinentV2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "EicDataList",
            Router: `/data/eicData`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "EicDataV2",
            Router: `/data/eicDataV2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "EicHistoryData",
            Router: `/data/eicHistoryData`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "EicHistoryDataV2",
            Router: `/data/eicHistoryDataV2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "EicLatestDate",
            Router: `/data/eicLatestDate`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "EicLatestDateV2",
            Router: `/data/eicLatestDateV2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "EicDataListV2",
            Router: `/data/eicSSODataV2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "ExchangeClassify",
            Router: `/data/exchange/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "ExchangeClassifyContract",
            Router: `/data/exchange/classifyContract`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "IneDataList",
            Router: `/data/ine`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "MtjhClassify",
            Router: `/data/mtjh/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "MtjhData",
            Router: `/data/mtjh/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "MtjhFrequency",
            Router: `/data/mtjh/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "MtjhSearchList",
            Router: `/data/mtjh/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "MtjhSingleData",
            Router: `/data/mtjh/single_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "ShfeDataList",
            Router: `/data/shfe`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "ZhengzhouDataList",
            Router: `/data/zhengzhou`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "ExportCoalList",
            Router: `/export/coalList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:TradeCommonController"],
        beego.ControllerComments{
            Method: "ExportMtjhList",
            Router: `/export/mtjh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "AreaCodeList",
            Router: `/area_code/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "BaseInfo",
            Router: `/base_info`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "ForgetAccountGet",
            Router: `/forget/account_get`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "ForgetCodeVerify",
            Router: `/forget/code_verify`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "ForgetResetPass",
            Router: `/forget/reset_pass`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "GenerateCaptcha",
            Router: `/get_captcha`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "CheckUserLdap",
            Router: `/ldap/user_check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "Login",
            Router: `/login`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "GetVerifyCode",
            Router: `/verify_code`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:VarietyTagController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:VarietyTagController"],
        beego.ControllerComments{
            Method: "TagTree",
            Router: `/variety_tag/tag_tree`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:VoiceCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:VoiceCommonController"],
        beego.ControllerComments{
            Method: "Download",
            Router: `/download`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:VoiceCommonController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:VoiceCommonController"],
        beego.ControllerComments{
            Method: "ReportChapterDownload",
            Router: `/report/download`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["eta/eta_api/controllers:VoiceController"] = append(beego.GlobalControllerRouter["eta/eta_api/controllers:VoiceController"],
        beego.ControllerComments{
            Method: "Upload",
            Router: `/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

}
